searchNodes=[{"doc":"Control an Access Control Unit (ACU) and send commands to a Peripheral Device (PD)","ref":"Jeff.html","title":"Jeff","type":"module"},{"doc":"Register a peripheral device on the ACU communication bus.","ref":"Jeff.html#add_pd/3","title":"Jeff.add_pd/3","type":"function"},{"doc":"Requests the PD to return a list of its functional capabilities, such as the type and number of input points, outputs points, reader ports, etc.","ref":"Jeff.html#capabilities/2","title":"Jeff.capabilities/2","type":"function"},{"doc":"Requests the return of the PD ID Report.","ref":"Jeff.html#id_report/2","title":"Jeff.id_report/2","type":"function"},{"doc":"Instructs the PD to reply with a local status report.","ref":"Jeff.html#local_status/2","title":"Jeff.local_status/2","type":"function"},{"doc":"Defines commands to a single, monotone audible annunciator (beeper or buzzer) that may be associated with a reader.","ref":"Jeff.html#set_buzzer/3","title":"Jeff.set_buzzer/3","type":"function"},{"doc":"Sets the PD's communication parameters.","ref":"Jeff.html#set_com/3","title":"Jeff.set_com/3","type":"function"},{"doc":"Controls the LEDs associated with one or more readers.","ref":"Jeff.html#set_led/3","title":"Jeff.set_led/3","type":"function"},{"doc":"Start an ACU process.","ref":"Jeff.html#start_acu/1","title":"Jeff.start_acu/1","type":"function"},{"doc":"","ref":"Jeff.html#t:acu/0","title":"Jeff.acu/0","type":"type"},{"doc":"","ref":"Jeff.html#t:device_opt/0","title":"Jeff.device_opt/0","type":"type"},{"doc":"","ref":"Jeff.html#t:osdp_address/0","title":"Jeff.osdp_address/0","type":"type"},{"doc":"GenServer process for an ACU","ref":"Jeff.ACU.html","title":"Jeff.ACU","type":"module"},{"doc":"Register a peripheral device on the ACU communication bus.","ref":"Jeff.ACU.html#add_device/3","title":"Jeff.ACU.add_device/3","type":"function"},{"doc":"Determine if a device is available to be registered on the bus.","ref":"Jeff.ACU.html#check_address/2","title":"Jeff.ACU.check_address/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Jeff.ACU.html#child_spec/1","title":"Jeff.ACU.child_spec/1","type":"function"},{"doc":"Send a command to a peripheral device.","ref":"Jeff.ACU.html#send_command/4","title":"Jeff.ACU.send_command/4","type":"function"},{"doc":"Send a command to a peripheral device that is not yet registered on the ACU. Intended to be used for maintenance/diagnostic purposes.","ref":"Jeff.ACU.html#send_command_oob/4","title":"Jeff.ACU.send_command_oob/4","type":"function"},{"doc":"Start the ACU process.","ref":"Jeff.ACU.html#start_link/1","title":"Jeff.ACU.start_link/1","type":"function"},{"doc":"","ref":"Jeff.ACU.html#t:acu/0","title":"Jeff.ACU.acu/0","type":"type"},{"doc":"","ref":"Jeff.ACU.html#t:address_availability/0","title":"Jeff.ACU.address_availability/0","type":"type"},{"doc":"","ref":"Jeff.ACU.html#t:device_opt/0","title":"Jeff.ACU.device_opt/0","type":"type"},{"doc":"","ref":"Jeff.ACU.html#t:osdp_address/0","title":"Jeff.ACU.osdp_address/0","type":"type"},{"doc":"","ref":"Jeff.ACU.html#t:start_opt/0","title":"Jeff.ACU.start_opt/0","type":"type"},{"doc":"Commands are sent from an ACU to a PD Code Name Description Data Type 0x60 POLL Poll - 0x61 ID ID Report Request - 0x62 CAP PD Capabilities Request [Capability] 0x64 LSTAT Local Status Report Request - 0x65 ISTAT Input Status Report Request - 0x66 OSTAT Output Status Report Request - 0x67 RSTAT Reader Status Report Request - 0x68 OUT Output Control Command OutputSettings 0x69 LED Reader Led Control Command LedSettings 0x6A BUZ Reader Buzzer Control Command BuzzerSettings 0x6B TEXT Text Output Command TextSettings 0x6E COMSET PD Communication Config Command ComSettings 0x73 BIOREAD Scan and Send Biometric Data Requested Return Format 0x74 BIOMATCH Scan and Match Biometric Template Biometric Template 0x75 KEYSET Encryption Key Set Command EncryptionKey 0x76 CHLNG Challenge/Secure Session Init Request ChallengeData 0x77 SCRYPT Server Cryptogram EncryptionData 0x7B ACURXSIZE Max ACU receive size Buffer size 0x7C FILETRANSFER Send data file to PD File contents 0x80 MFG Manufacturer Specific Command Any 0xA1 XWR Extended write data APDU and details 0xA2 ABORT Abort PD operation - 0xA3 PIVDATA Get PIV Data Object details 0xA4 GENAUTH Request Authenticate Request details 0xA5 CRAUTH Request Crypto Response Challenge details 0xA7 KEEPACTIVE PD read activation Time duration","ref":"Jeff.Command.html","title":"Jeff.Command","type":"module"},{"doc":"","ref":"Jeff.Command.html#code/1","title":"Jeff.Command.code/1","type":"function"},{"doc":"","ref":"Jeff.Command.html#name/1","title":"Jeff.Command.name/1","type":"function"},{"doc":"","ref":"Jeff.Command.html#new/3","title":"Jeff.Command.new/3","type":"function"},{"doc":"","ref":"Jeff.Command.html#t:t/0","title":"Jeff.Command.t/0","type":"type"},{"doc":"Reader Buzzer Control Command OSDP v2.2 Specification Reference: 6.11","ref":"Jeff.Command.BuzzerSettings.html","title":"Jeff.Command.BuzzerSettings","type":"module"},{"doc":"","ref":"Jeff.Command.BuzzerSettings.html#encode/1","title":"Jeff.Command.BuzzerSettings.encode/1","type":"function"},{"doc":"","ref":"Jeff.Command.BuzzerSettings.html#new/1","title":"Jeff.Command.BuzzerSettings.new/1","type":"function"},{"doc":"The number of times to repeat the ON/OFF cycle. 0 = tone continues until another tone command is received.","ref":"Jeff.Command.BuzzerSettings.html#t:count/0","title":"Jeff.Command.BuzzerSettings.count/0","type":"type"},{"doc":"The OFF duration of the sound, in units of 100ms.","ref":"Jeff.Command.BuzzerSettings.html#t:off_time/0","title":"Jeff.Command.BuzzerSettings.off_time/0","type":"type"},{"doc":"The ON duration of the sound, in units of 100ms. Must be nonzero unless the tone code is 0x01 (off).","ref":"Jeff.Command.BuzzerSettings.html#t:on_time/0","title":"Jeff.Command.BuzzerSettings.on_time/0","type":"type"},{"doc":"","ref":"Jeff.Command.BuzzerSettings.html#t:param/0","title":"Jeff.Command.BuzzerSettings.param/0","type":"type"},{"doc":"","ref":"Jeff.Command.BuzzerSettings.html#t:params/0","title":"Jeff.Command.BuzzerSettings.params/0","type":"type"},{"doc":"","ref":"Jeff.Command.BuzzerSettings.html#t:t/0","title":"Jeff.Command.BuzzerSettings.t/0","type":"type"},{"doc":"Requested tone state 0x00 = no tone (off) – use of this value is deprecated. 0x01 = off 0x02 = default tone 0x03-0xff = Reserved for future use","ref":"Jeff.Command.BuzzerSettings.html#t:tone_code/0","title":"Jeff.Command.BuzzerSettings.tone_code/0","type":"type"},{"doc":"Communication configuration command OSDP v2.2 Specification Reference: 6.13","ref":"Jeff.Command.ComSettings.html","title":"Jeff.Command.ComSettings","type":"module"},{"doc":"","ref":"Jeff.Command.ComSettings.html#encode/1","title":"Jeff.Command.ComSettings.encode/1","type":"function"},{"doc":"","ref":"Jeff.Command.ComSettings.html#new/1","title":"Jeff.Command.ComSettings.new/1","type":"function"},{"doc":"","ref":"Jeff.Command.ComSettings.html#t:baud/0","title":"Jeff.Command.ComSettings.baud/0","type":"type"},{"doc":"","ref":"Jeff.Command.ComSettings.html#t:param/0","title":"Jeff.Command.ComSettings.param/0","type":"type"},{"doc":"","ref":"Jeff.Command.ComSettings.html#t:params/0","title":"Jeff.Command.ComSettings.params/0","type":"type"},{"doc":"","ref":"Jeff.Command.ComSettings.html#t:t/0","title":"Jeff.Command.ComSettings.t/0","type":"type"},{"doc":"Reader LED control command OSDP v2.2 Specification Reference: 6.10 Temporary Control Code Values | Code | Description |------|----------------------------------------------------------------------------------------------------------------------| | 0x00 | NOP – do not alter this LED's temporary settings. The remaining values of the temporary settings record are ignored. | | 0x01 | Cancel any temporary operation and display this LED's permanent state immediately. | | 0x02 | Set the temporary state as given and start timer immediately. | Permanent Control Code Values | Code | Description |-----------------------------------------------------------------------------------------------------------------------------| | 0x00 | NOP – do not alter this LED's permanent settings. The remaining values of the temporary settings record are ignored. | | 0x01 | Set the permanent state as given. | Color Values | Value | Description | |---------------------------| | 0 | Black (off/unlit) | | 1 | Red | | 2 | Green | | 3 | Amber | | 4 | Blue | | 5 | Magenta | | 6 | Cyan | | 7 | White |","ref":"Jeff.Command.LedSettings.html","title":"Jeff.Command.LedSettings","type":"module"},{"doc":"","ref":"Jeff.Command.LedSettings.html#encode/1","title":"Jeff.Command.LedSettings.encode/1","type":"function"},{"doc":"","ref":"Jeff.Command.LedSettings.html#new/1","title":"Jeff.Command.LedSettings.new/1","type":"function"},{"doc":"","ref":"Jeff.Command.LedSettings.html#t:param/0","title":"Jeff.Command.LedSettings.param/0","type":"type"},{"doc":"","ref":"Jeff.Command.LedSettings.html#t:params/0","title":"Jeff.Command.LedSettings.params/0","type":"type"},{"doc":"","ref":"Jeff.Command.LedSettings.html#t:t/0","title":"Jeff.Command.LedSettings.t/0","type":"type"},{"doc":"Output control command OSDP v2.2 Specification Reference: 6.7 Control Code Values Code Description 0x00 NOP – do not alter this output 0x01 Set the permanent state to OFF, abort timed operation (if any) 0x02 Set the permanent state to ON, abort timed operation (if any) 0x03 Set the permanent state to OFF, allow timed operation to complete 0x04 Set the permanent state to ON, allow timed operation to complete 0x05 Set the temporary state to ON, resume permanent state on timeout 0x06 Set the temporary state to OFF, resume permanent state on timeout","ref":"Jeff.Command.OutputSettings.html","title":"Jeff.Command.OutputSettings","type":"module"},{"doc":"","ref":"Jeff.Command.OutputSettings.html#encode/1","title":"Jeff.Command.OutputSettings.encode/1","type":"function"},{"doc":"Peripheral Device configuration and handling","ref":"Jeff.Device.html","title":"Jeff.Device","type":"module"},{"doc":"","ref":"Jeff.Device.html#inc_sequence/1","title":"Jeff.Device.inc_sequence/1","type":"function"},{"doc":"","ref":"Jeff.Device.html#new/1","title":"Jeff.Device.new/1","type":"function"},{"doc":"","ref":"Jeff.Device.html#next_command/1","title":"Jeff.Device.next_command/1","type":"function"},{"doc":"","ref":"Jeff.Device.html#online?/1","title":"Jeff.Device.online?/1","type":"function"},{"doc":"","ref":"Jeff.Device.html#receive_valid_reply/1","title":"Jeff.Device.receive_valid_reply/1","type":"function"},{"doc":"","ref":"Jeff.Device.html#send_command/2","title":"Jeff.Device.send_command/2","type":"function"},{"doc":"","ref":"Jeff.Device.html#t:check_scheme/0","title":"Jeff.Device.check_scheme/0","type":"type"},{"doc":"","ref":"Jeff.Device.html#t:sequence_number/0","title":"Jeff.Device.sequence_number/0","type":"type"},{"doc":"","ref":"Jeff.Device.html#t:t/0","title":"Jeff.Device.t/0","type":"type"},{"doc":"Event that is triggered when readers receive input from card reads","ref":"Jeff.Events.CardRead.html","title":"Jeff.Events.CardRead","type":"module"},{"doc":"","ref":"Jeff.Events.CardRead.html#from_reply/1","title":"Jeff.Events.CardRead.from_reply/1","type":"function"},{"doc":"","ref":"Jeff.Events.CardRead.html#t:t/0","title":"Jeff.Events.CardRead.t/0","type":"type"},{"doc":"Event that is triggered when readers receive input to keypads","ref":"Jeff.Events.Keypress.html","title":"Jeff.Events.Keypress","type":"module"},{"doc":"","ref":"Jeff.Events.Keypress.html#from_reply/1","title":"Jeff.Events.Keypress.from_reply/1","type":"function"},{"doc":"","ref":"Jeff.Events.Keypress.html#t:t/0","title":"Jeff.Events.Keypress.t/0","type":"type"},{"doc":"Implements framing for OSDP packets. Waits for a driver byte, then start of message byte, then the length bytes. Continues to accumulate bytes until the message length has been reached.","ref":"Jeff.Framing.html","title":"Jeff.Framing","type":"module"},{"doc":"","ref":"Jeff.Framing.html#process_data/2","title":"Jeff.Framing.process_data/2","type":"function"},{"doc":"Replies are sent from a PD to an ACU in response to a command Name Code Description Data Type ACK 0x40 Command accepted, nothing else to report - NAK 0x41 Command not processed ErrorCode PDID 0x45 PD ID Report IdReport PDCAP 0x46 PD Capabilities Report [Capability] LSTATR 0x48 Local Status Report Report data ISTATR 0x49 Input Status Report Report data OSTATR 0x4A Output Status Report Report data RSTATR 0x4B Reader Status Report Report data RAW 0x50 Reader Data – Raw bit image of card data CardData FMT 0x51 Reader Data – Formatted character stream CardData KEYPAD 0x53 Keypad Data KeypadData COM 0x54 PD Communications Configuration Report ComData BIOREADR 0x57 Biometric Data Biometric data BIOMATCHR 0x58 Biometric Match Result Result CCRYPT 0x76 Client's ID, Random Number, and Cryptogram EncryptionClient BUSY 0x79 PD is Busy reply - RMAC_I 0x78 Initial R-MAC Encryption Data FTSTAT 0x7A File transfer status Status details PIVDATAR 0x80 PIV Data Reply credential data GENAUTHR 0x81 Authentication response response details CRAUTHR 0x82 Response to challenge response details MFGSTATR 0x83 MFG specific status status details MFGERRR 0x84 MFG specific error error details MFGREP 0x90 Manufacturer Specific Reply Any XRD 0xB1 Extended Read Response APDU and details","ref":"Jeff.Reply.html","title":"Jeff.Reply","type":"module"},{"doc":"","ref":"Jeff.Reply.html#code/1","title":"Jeff.Reply.code/1","type":"function"},{"doc":"","ref":"Jeff.Reply.html#name/1","title":"Jeff.Reply.name/1","type":"function"},{"doc":"","ref":"Jeff.Reply.html#new/1","title":"Jeff.Reply.new/1","type":"function"},{"doc":"","ref":"Jeff.Reply.html#new/3","title":"Jeff.Reply.new/3","type":"function"},{"doc":"","ref":"Jeff.Reply.html#t:t/0","title":"Jeff.Reply.t/0","type":"type"},{"doc":"Peripheral Device Capabilities Report OSDP v2.2 Specification Reference: 7.5","ref":"Jeff.Reply.Capability.html","title":"Jeff.Reply.Capability","type":"module"},{"doc":"","ref":"Jeff.Reply.Capability.html#decode/1","title":"Jeff.Reply.Capability.decode/1","type":"function"},{"doc":"","ref":"Jeff.Reply.Capability.html#new/3","title":"Jeff.Reply.Capability.new/3","type":"function"},{"doc":"","ref":"Jeff.Reply.Capability.html#t:t/0","title":"Jeff.Reply.Capability.t/0","type":"type"},{"doc":"Card Data Report OSDP v2.2 Specification Reference: 7.10","ref":"Jeff.Reply.CardData.html","title":"Jeff.Reply.CardData","type":"module"},{"doc":"","ref":"Jeff.Reply.CardData.html#decode/1","title":"Jeff.Reply.CardData.decode/1","type":"function"},{"doc":"Communication Configuration Report OSDP v2.2 Specification Reference: 7.13","ref":"Jeff.Reply.ComData.html","title":"Jeff.Reply.ComData","type":"module"},{"doc":"","ref":"Jeff.Reply.ComData.html#decode/1","title":"Jeff.Reply.ComData.decode/1","type":"function"},{"doc":"","ref":"Jeff.Reply.ComData.html#t:t/0","title":"Jeff.Reply.ComData.t/0","type":"type"},{"doc":"Negative Acknowledge – Error Response OSDP v2.2 Specification Reference: 7.3","ref":"Jeff.Reply.ErrorCode.html","title":"Jeff.Reply.ErrorCode","type":"module"},{"doc":"","ref":"Jeff.Reply.ErrorCode.html#decode/1","title":"Jeff.Reply.ErrorCode.decode/1","type":"function"},{"doc":"","ref":"Jeff.Reply.ErrorCode.html#new/1","title":"Jeff.Reply.ErrorCode.new/1","type":"function"},{"doc":"","ref":"Jeff.Reply.ErrorCode.html#t:t/0","title":"Jeff.Reply.ErrorCode.t/0","type":"type"},{"doc":"Device identification Report OSDP v2.2 Specification Reference: 7.4","ref":"Jeff.Reply.IdReport.html","title":"Jeff.Reply.IdReport","type":"module"},{"doc":"","ref":"Jeff.Reply.IdReport.html#decode/1","title":"Jeff.Reply.IdReport.decode/1","type":"function"},{"doc":"","ref":"Jeff.Reply.IdReport.html#t:t/0","title":"Jeff.Reply.IdReport.t/0","type":"type"},{"doc":"Keypad Data Report OSDP v2.2 Specification Reference: 7.12","ref":"Jeff.Reply.KeypadData.html","title":"Jeff.Reply.KeypadData","type":"module"},{"doc":"","ref":"Jeff.Reply.KeypadData.html#decode/1","title":"Jeff.Reply.KeypadData.decode/1","type":"function"},{"doc":"Local Status Report OSDP v2.2 Specification Reference: 7.6","ref":"Jeff.Reply.LocalStatus.html","title":"Jeff.Reply.LocalStatus","type":"module"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#decode/1","title":"Jeff.Reply.LocalStatus.decode/1","type":"function"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#new/2","title":"Jeff.Reply.LocalStatus.new/2","type":"function"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#t:power_code/0","title":"Jeff.Reply.LocalStatus.power_code/0","type":"type"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#t:power_status/0","title":"Jeff.Reply.LocalStatus.power_status/0","type":"type"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#t:t/0","title":"Jeff.Reply.LocalStatus.t/0","type":"type"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#t:tamper_code/0","title":"Jeff.Reply.LocalStatus.tamper_code/0","type":"type"},{"doc":"","ref":"Jeff.Reply.LocalStatus.html#t:tamper_status/0","title":"Jeff.Reply.LocalStatus.tamper_status/0","type":"type"},{"doc":"An Elixir implementation of the Open Supervised Device Protocol (OSDP). Open Supervised Device Protocol (OSDP) is an access control communications standard developed by the Security Industry Association (SIA). The OSDP standard describes the communication interface of one or more Peripheral Devices (PD) to an Access Control Unit (ACU). The specification describes the protocol implementation over a two-wire RS-485 multi-drop serial communication channel. OSDP Supports the control of components on a PD such as: LED Buzzer Keypad Output (GPIOs) Input Control (GPIOs) Displays Device status (tamper, power, etc.) Card Reader Fingerprint Reader","ref":"readme.html","title":"Jeff","type":"extras"},{"doc":"{ :ok , acu } = Jeff . start_acu ( serial_port : &quot;/dev/ttyUSB0&quot; ) Jeff . add_pd ( acu , 0x7F , check_scheme : :crc ) Jeff . id_report ( acu , 0x7F )","ref":"readme.html#example","title":"Jeff - Example","type":"extras"},{"doc":"Copyright (C) 2022 SmartRent Licensed under the Apache License , Version 2.0 ( the &quot;License&quot; ) ; you may not use this file except in compliance with the License . You may obtain a copy of the License at [ http :// www . apache . org / licenses / LICENSE - 2.0 ] ( http :// www . apache . org / licenses / LICENSE - 2.0 ) Unless required by applicable law or agreed to in writing , software distributed under the License is distributed on an &quot;AS IS&quot; BASIS , WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND , either express or implied . See the License for the specific language governing permissions and limitations under the License .","ref":"readme.html#license","title":"Jeff - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Changed Improve documentation and typespecs Improve README and docs Rename ControlPanel -&gt; ACU Added Add LICENSE info","ref":"changelog.html#v0-3-0-2022-03-09","title":"CHANGELOG - [v0.3.0] - 2022-03-09","type":"extras"},{"doc":"Added Send out-of-band commands: send commands to devices not yet registered to the communication bus loop. Check OSDP address: Checks whether address is available to register to a bus.","ref":"changelog.html#v0-2-0-2022-02-10","title":"CHANGELOG - [v0.2.0] - 2022-02-10","type":"extras"}]